﻿using Syncfusion.SfCalendar.XForms;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Text;
using Xamarin.Forms;

namespace CustomInlineViewSample
{
    class CalendarBehavior : Behavior<ContentPage>
    {
        SfCalendar calendar;
        DatePicker DatePicker;
        Label label;
        int year;

        Label monthLabel1;
        Label monthLabel2;
        Label monthLabel3;
        Label monthLabel4;
        Label monthLabel5;
        Label monthLabel6;
        Label monthLabel7;
        Label monthLabel8;
        Label monthLabel9;
        Label monthLabel10;
        Label monthLabel11;
        Label monthLabel12;
        protected override void OnAttachedTo(ContentPage bindable)
        {
            base.OnAttachedTo(bindable);
            calendar = bindable.FindByName<SfCalendar>("calendar");
            label = bindable.FindByName<Label>("label");
            DatePicker = bindable.FindByName<DatePicker>("DatePicker");
            DatePicker.DateSelected += DatePicker_DateSelected;
            calendar.OnMonthCellLoaded += Calendar_OnMonthCellLoaded;
            calendar.OnCalendarTapped += Calendar_OnCalendarTapped;

            monthLabel1 = bindable.FindByName<Label>("monthLabel1");
            monthLabel2 = bindable.FindByName<Label>("monthLabel2");
            monthLabel3 = bindable.FindByName<Label>("monthLabel3");
            monthLabel4 = bindable.FindByName<Label>("monthLabel4");
            monthLabel5 = bindable.FindByName<Label>("monthLabel5");
            monthLabel6 = bindable.FindByName<Label>("monthLabel6");
            monthLabel7 = bindable.FindByName<Label>("monthLabel7");
            monthLabel8 = bindable.FindByName<Label>("monthLabel8");
            monthLabel9 = bindable.FindByName<Label>("monthLabel9");
            monthLabel10 = bindable.FindByName<Label>("monthLabel10");
            monthLabel11 = bindable.FindByName<Label>("monthLabel11");
            monthLabel12 = bindable.FindByName<Label>("monthLabel12");

            var month1 = new TapGestureRecognizer();
            month1.Tapped += (s, e) =>
             {
                 calendar.MoveToDate = new DateTime(year, 1, 1);
             };
            var month2 = new TapGestureRecognizer();
            month2.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 2, 1);
            };
            var month3 = new TapGestureRecognizer();
            month3.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 3, 1);
            };
            var month4 = new TapGestureRecognizer();
            month4.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 4, 1);
            };
            var month5 = new TapGestureRecognizer();
            month5.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 5, 1);
            };
            var month6 = new TapGestureRecognizer();
            month6.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 6, 1);
            };
            var month7 = new TapGestureRecognizer();
            month7.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 7, 1);
            };
            var month8 = new TapGestureRecognizer();
            month8.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 8, 1);
            };
            var month9 = new TapGestureRecognizer();
            month9.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 9, 1);
            };
            var month10 = new TapGestureRecognizer();
            month10.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 10, 1);
            };
            var month11 = new TapGestureRecognizer();
            month11.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 11, 1);
            };
            var month12 = new TapGestureRecognizer();
            month12.Tapped += (s, e) =>
            {
                calendar.MoveToDate = new DateTime(year, 12, 1);
            };

            monthLabel1.GestureRecognizers.Add(month1);
            monthLabel2.GestureRecognizers.Add(month2);
            monthLabel3.GestureRecognizers.Add(month3);
            monthLabel4.GestureRecognizers.Add(month4);
            monthLabel5.GestureRecognizers.Add(month5);
            monthLabel6.GestureRecognizers.Add(month6);
            monthLabel7.GestureRecognizers.Add(month7);
            monthLabel8.GestureRecognizers.Add(month8);
            monthLabel9.GestureRecognizers.Add(month9);
            monthLabel10.GestureRecognizers.Add(month10);
            monthLabel11.GestureRecognizers.Add(month11);
            monthLabel12.GestureRecognizers.Add(month12);
        }

        private void Calendar_OnCalendarTapped(object sender, CalendarTappedEventArgs e)
        {
            label.Text = e.DateTime.Year.ToString() + CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName(e.DateTime.Month);
            year = e.DateTime.Year;
        }

        private void Calendar_OnMonthCellLoaded(object sender, MonthCellLoadedEventArgs e)
        {
            Label label = new Label();
            label.Text = e.Date.Day.ToString();
            label.BackgroundColor= Color.FromRgb(4, 21, 48);
            label.TextColor = Color.White;
            e.View = label;
        }

        private void DatePicker_DateSelected(object sender, DateChangedEventArgs e)
        {
            calendar.MoveToDate = e.NewDate;
            label.Text = e.NewDate.Year.ToString() + CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName(e.NewDate.Month);
            year = e.NewDate.Year;
        }
    }
}
